package cn.timer.api.bean.jxgl;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author LAL 2020-01-02
 */
@Entity
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "jxgl_admin_jcsz")
@ApiModel("基础设置")
public class JxglAdminJcsz extends Model<JxglAdminJcsz> {

	private static final long serialVersionUID = 8687909529181749192L;

	@Id
	@GeneratedValue
	@TableId(type = IdType.AUTO)
	@ApiModelProperty(value = "id id", example = "101")
	private Integer id;

	@ApiModelProperty(value = "OKR开关 0：关；1：开（目标（Objectives）与关键成果法（Key Results））", example = "101")
	private Integer isOrk;
	
	@ApiModelProperty(value = "绩效考核开关 0：关；1：开（支持KPI、BSC、360互评等多种考核方式）", example = "101")
	private Integer isJxkh;

	@ApiModelProperty(value = "计算规则 0：量化指标和行为价值观指标合并计算；1：量化指标和行为价值观指标分开计算", example = "101")
	private Integer jsgz;

	@ApiModelProperty(value = "量化指标 0：数字型；1：文本型", example = "101")
	private Integer lhzb;

	@ApiModelProperty(value = "总分自动加和开关 0：关；1：开", example = "101")
	private Integer lhzbZfzdjh;

	@ApiModelProperty(value = "录入方式  0：文本框输入；1：下拉选择", example = "101")
	private Integer lhzbLrfs;

	@ApiModelProperty(value = "行为价值观指标 0：数字型；1：文本型", example = "101")
	private Integer xwjzgzb;

	@ApiModelProperty(value = "总分自动加和开关 0：关；1：开", example = "101")
	private Integer xwjzgzbZfzdjh;

	@ApiModelProperty(value = "录入方式  0：文本框输入；1：下拉选择", example = "101")
	private Integer xwjzgzbLrfs;

	@ApiModelProperty(value = "绩效等级开关 0：关；1：开", example = "101")
	private Integer jxdjkg;

	@ApiModelProperty(value = "绩效等级类型 0：强制正态分布；1：分数区间对应", example = "101")
	private Integer jxdjtype;

	@ApiModelProperty(value = "对接人事管理开关 0：关；1：开", example = "101")
	private Integer djrsgl;

	@ApiModelProperty(value = "待办自动提醒开关 0：关；1：开", example = "101")
	private Integer dbzdtx;

	@ApiModelProperty(value = "分制名称 ", example = "分制名称")
	private String fzmc;

	@ApiModelProperty(value = "满分 ", example = "满分")
	private String manfen;

	@ApiModelProperty(value = "企业id 企业id", example = "101")
	private Integer qyid;

	@ApiModelProperty(value = "添加人员ID 添加人员ID", example = "101")
	private Integer tjryid;

}