package cn.timer.api.bean.jxgl;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author LAL 2020-01-02
 */
@Entity
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "jxgl_asso_zbzdsz")
@ApiModel("指标字段设置")
public class JxglAssoZbzdsz extends Model<JxglAssoZbzdsz> {

	private static final long serialVersionUID = -7704484193612123538L;

	@Id
	@GeneratedValue
	@TableId(type = IdType.AUTO)
	@ApiModelProperty(value = "id id", example = "101")
	private Integer id;

	@ApiModelProperty(value = "字段名称 ", example = "字段名称")
	private String name;

	@ApiModelProperty(value = "字段类型 1：数字/文本(如果指标的公式计算使用此变量，则强制指标的此变量和录入结果值为数字类型)", example = "101")
	private Integer type;

	@ApiModelProperty(value = "是否启用 0：否；1：是", example = "101")
	private Integer isSfqy;

	@ApiModelProperty(value = "是否开启公式变量 0：否；1：是(开启后，可以作为变量用于指标的公式计算)", example = "101")
	private Integer isGsbl;

	@ApiModelProperty(value = "设置id 设置id", example = "101")
	private Integer jcszid;
	
	@ApiModelProperty(value = "企业id 企业id", example = "101")
	private Integer qyid;

}