package cn.timer.api.bean.kqgl;

import java.io.Serializable;
import java.text.SimpleDateFormat;

import lombok.AllArgsConstructor;
import lombok.NoArgsConstructor;

/**
 * @author lalqq 打卡记录
 */
@AllArgsConstructor
@NoArgsConstructor
public class PunchRecord implements Serializable {

	private static final long serialVersionUID = -1674107232385310352L;

	private Integer id;
	private Long dktime;// 打卡时间
	private String Strdktime = "";//
	private Double lon;// 经度
	private Double lat;// 纬度
	private String address;// 定位地址
	private Integer results;// 打卡结果
	private Integer userId;// 用户id
	private Integer type;// 类型(类型 0:无排班打卡 1：上班 2：下班)
	private Integer status;// 状态（0：打卡无效:此记录已被更新 1：正常 2：异常 3：迟到 4：早退 5：补卡 6：请假 7：加班 8：请假迟到 9：请假早退 10：调休）',
	private Integer sort;// 序号
	private Integer cardType;// 打卡类型（1：GPS，2：WIFI，3：考勤机）
	private String mac;// mac地址
	private String macname;// WIFI名称
	private Integer qyid;// 企业id
	private String attdate;// 考勤日期
	private Long attime;// 考勤时间
	private String Strattime = "";//
	private Integer dkmxid;// 打卡明细id
	private Integer bcid;// 班次id
	private String remarks;// 考勤备注
	private Integer punchmode;// 考勤机打卡方式==>1：指紋；2：人脸；3：密码；4：ID卡
	private String punchequipment;// 打卡设备

	private String username = "";
	private String dept = "";
	private String post = "";

	SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public Long getDktime() {
		return dktime;
	}

	@SuppressWarnings("unlikely-arg-type")
	public void setDktime(Long dktime) {
		this.dktime = dktime;
		if (dktime != null && !dktime.equals("")) {
			this.Strdktime = format.format(dktime);
		}
	}

	public String getStrdktime() {
		return Strdktime;
	}

	public void setStrdktime(String strdktime) {
		Strdktime = strdktime;
	}

	public Double getLon() {
		return lon;
	}

	public void setLon(Double lon) {
		this.lon = lon;
	}

	public Double getLat() {
		return lat;
	}

	public void setLat(Double lat) {
		this.lat = lat;
	}

	public String getAddress() {
		return address;
	}

	public void setAddress(String address) {
		this.address = address == null ? "" : address.trim();
	}

	public Integer getResults() {
		return results;
	}

	public void setResults(Integer results) {
		this.results = results;
	}

	public Integer getUserId() {
		return userId;
	}

	public void setUserId(Integer userId) {
		this.userId = userId;
	}

	public Integer getType() {
		return type;
	}

	public void setType(Integer type) {
		this.type = type;
	}

	public Integer getStatus() {
		return status;
	}

	public void setStatus(Integer status) {
		this.status = status;
	}

	public Integer getSort() {
		return sort;
	}

	public void setSort(Integer sort) {
		this.sort = sort;
	}

	public Integer getCardType() {
		return cardType;
	}

	public void setCardType(Integer cardType) {
		this.cardType = cardType;
	}

	public String getMacname() {
		return macname;
	}

	public void setMacname(String macname) {
		this.macname = macname == null ? "" : macname.trim();
	}

	public String getMac() {
		return mac;
	}

	public void setMac(String mac) {
		this.mac = mac == null ? "" : mac.trim();
	}

	public Integer getQyid() {
		return qyid;
	}

	public void setQyid(Integer qyid) {
		this.qyid = qyid;
	}

	public String getAttdate() {
		return attdate;
	}

	public void setAttdate(String attdate) {
		this.attdate = attdate == null ? "" : attdate.trim();
	}

	public Long getAttime() {
		return attime;
	}

	@SuppressWarnings("unlikely-arg-type")
	public void setAttime(Long attime) {
		this.attime = attime;

		if (attime != null && !attime.equals("")) {
			this.Strattime = format.format(attime);
		}
	}

	public String getStrattime() {
		return Strattime;
	}

	public void setStrattime(String strattime) {
		Strattime = strattime;
	}

	public Integer getDkmxid() {
		return dkmxid;
	}

	public void setDkmxid(Integer dkmxid) {
		this.dkmxid = dkmxid;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public Integer getBcid() {
		return bcid;
	}

	public void setBcid(Integer bcid) {
		this.bcid = bcid;
	}

	public String getRemarks() {
		return remarks;
	}

	public void setRemarks(String remarks) {
		this.remarks = remarks;
	}

	public Integer getPunchmode() {
		return punchmode;
	}

	public void setPunchmode(Integer punchmode) {
		this.punchmode = punchmode;
	}

	public String getPunchequipment() {
		return punchequipment;
	}

	public void setPunchequipment(String punchequipment) {
		this.punchequipment = punchequipment;
	}

	public String getDept() {
		return dept;
	}

	public void setDept(String dept) {
		this.dept = dept;
	}

	public String getPost() {
		return post;
	}

	public void setPost(String post) {
		this.post = post;
	}

}