package cn.timer.api.bean.spmk;

import java.util.Date;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
* @author Tang 2019-11-26
*/
@Entity
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name="spmk_spcz")
@ApiModel("审批操作")
public class SpmkSpcz extends Model<SpmkSpcz> {

	private static final long serialVersionUID = 3566026137671837723L;

	@Id
    @GeneratedValue
    @TableId (type = IdType.AUTO)
	@ApiModelProperty(value="编号",example="101")
    private Integer id;
    
	@ApiModelProperty(value="审批管理id",example="101")
    private Integer spglId;
    
	@ApiModelProperty(value="标题",example="标题")
    private String title;
    
	@ApiModelProperty(value="摘要",example="摘要")
    private String digest;
    
	@ApiModelProperty(value="当前审批人",example="101")
    private Integer sprEmpNum;
    
	@ApiModelProperty(value="当前状态 0审批中 1已撤回 2已拒绝 3已审批 4草稿箱",example="101")
    private Integer sts;
    
	@ApiModelProperty(value="流程名称 ",example="流程名称")
    private String lcmc;
    
	@ApiModelProperty(value="发起时间 ",example="2019-10-10 10:10:10")
    private Date createTime;
    
	@ApiModelProperty(value="结束时间 ",example="2019-10-10 10:10:10")
    private Date endTime;
	
	@ApiModelProperty(value="内容 ",example="")
	private byte[] nr;
	
	/**
	 * 	审批内容
	 */
	@Transient
	@TableField(exist = false)
	private List<SpmkSpnr> spmkSpnrs;
	
	/**
	 * 	处理人
	 */
	@Transient
	@TableField(exist = false)
	private List<SpmkClr> spmkClrs;
	
}