package cn.timer.api.bean.spmk;

import java.util.Date;
import javax.persistence.*;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
* @author Tang 2019-11-22
*/
@Entity
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name="spmk_spgl")
@ApiModel("审批管理")
public class SpmkSpgl extends Model<SpmkSpgl> {

	private static final long serialVersionUID = -4266670348589252169L;

	@Id
    @GeneratedValue
    @TableId (type = IdType.AUTO)
	@ApiModelProperty(value="编号",example="1")
    private Integer id;
    
	@ApiModelProperty(value="审批组id",example="10")
    private Integer spzId;
	
	@ApiModelProperty(value="企业id",example="10")
	private Integer orgCode;
    
	@ApiModelProperty(value="审批模版_id",example="10")
    private Integer mbId;
    
	@ApiModelProperty(value="审批图标地址 ",example="审批图标地址")
    private String iconAddress;
    
	@ApiModelProperty(value="审批名称 ",example="审批名称")
    private String name;
    
	@ApiModelProperty(value="审批说明 ",example="审批说明")
    private String description;
    
	@ApiModelProperty(value="审批开关 0启用 1停用",example="0")
    private Integer isOpen;
    
	@ApiModelProperty(value="排序 排序",example="1")
    private Integer sort;
    
	@ApiModelProperty(value="审批人去重 0不启用自动去重 1同一个审批人在流程中出现多次时，仅保留第一个 2同一个审批人仅在连续出现时，自动去重",example="0")
    private Integer sprqcType;
    
	@ApiModelProperty(value="填写提示 ",example="填写提示")
    private String txts;
    
	@ApiModelProperty(value="审批意见 ",example="1,2,3")
    private String spyj;
    
	@ApiModelProperty(value="自动通过 发起人审批时自动通过 0是 1否",example="0")
    private Integer isZdtg;
    
	@ApiModelProperty(value="打印模板 0默认模版 1自定义模版",example="0")
    private Integer dymbType;
    
	@ApiModelProperty(value="必须签名 是否 同意时必须签名  0是 1否",example="0")
    private Integer isBxqm;
    
	@ApiModelProperty(value="使用上次签名 0是 1否",example="0")
    private Integer isSyscqm;
    
	@ApiModelProperty(value="每次重新签名 0是 1否",example="0")
    private Integer isMccxqm;
    
	@ApiModelProperty(value="流程节点",example="0")
	private byte[] lcjd;
	
	@TableField(fill = FieldFill.UPDATE)
	@ApiModelProperty(value="更新时间 ",example="更新时间")
    private Date updateTime;
    
	@TableField(fill = FieldFill.INSERT)
	@ApiModelProperty(value="创建时间 ",example="创建时间")
    private Date createTime;
	
	@Transient
	@TableField(exist = false)
	private SpmkMb spmkMb;

}