package cn.timer.api.dto.yggl;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;

import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.service.additional.query.impl.LambdaQueryChainWrapper;

import cn.timer.api.dao.yggl.YgCityDtoMapper;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
* @author Tang 2019-11-15
*/

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@TableName("pro_city_class")
@ApiModel("籍贯:城市")
public class YgCityDto implements IYgjgDto,InitializingBean{
	@Id
    @GeneratedValue
    @TableId (type = IdType.AUTO)
	@ApiModelProperty(value="编号",example="1")
    private Integer id;
    
	@ApiModelProperty(value="省编码 ",example="省编码")
    private Integer province;
    
	@ApiModelProperty(value="市编码",example="市编码")
    private Integer city;
	
	@ApiModelProperty(value="名字",example="名字")
    private String name;
	
	@Autowired
	private YgCityDtoMapper ygCityDtoMapper;
	
	public List<String> exePunish() {
	       List<YgCityDto> cityList = new LambdaQueryChainWrapper<YgCityDto>(ygCityDtoMapper).orderByAsc(YgCityDto::getProvince).list();
	       List<String> c =new ArrayList<String>();
	       for (YgCityDto city : cityList) { c.add(city.getName()); }
	       return c;
	    }
    
    public void afterPropertiesSet(){
        PunishFactory.registerPunish("city", this);
    }
	
}
